/*
   Get a character from the stdin, put it into a buffer (which has a size
   of BUFSIZE.  <B>getch</B> gets a character out of the buffer (if stdin
   is finished, an EOF is returned), and <B>ungetch</B> puts back a character
   into the buffer.
*/
#include <stdio.h>
#include "getch.h"

char buf[BUFSIZE];
int sp = 0;

int getch(void) {
    return (sp > 0) ? buf[--sp] : getchar();
}

void ungetch(int c) {
    if (sp >= BUFSIZE)
	fprintf(stderr, "ERROR.  ungetch: buffer is full.\n");
    else
	buf[sp++] = c;
}
